"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAuthRouter = createAuthRouter;
const express_1 = require("express");
const init_1 = require("./init");
__exportStar(require("./types"), exports);
const UserController = __importStar(require("./controllers/UserController"));
const mongoose_1 = __importDefault(require("mongoose"));
const auth_1 = require("./middlewares/auth");
let isConnected = false;
function connectDB(mongoUrl) {
    return __awaiter(this, void 0, void 0, function* () {
        if (isConnected) {
            console.log('MongoDB is already connected');
            return;
        }
        try {
            console.log('Connecting to MongoDB...');
            yield mongoose_1.default.connect(mongoUrl);
            isConnected = true;
            console.log('MongoDB connected successfully');
        }
        catch (error) {
            console.error('Error connecting to MongoDB:', error);
            throw error;
        }
    });
}
function createAuthRouter(config) {
    if (!config.mongoUrl) {
        throw new Error('mongoURI is required in the configuration');
    }
    connectDB(config.mongoUrl)
        .then(() => console.log('Database connection ready for auth router'))
        .catch((err) => console.error('Database connection failed:', err));
    (0, init_1.init)(config);
    const router = (0, express_1.Router)();
    router.get('/', auth_1.requiresAuth, UserController.authenticate);
    router.post('/signup', UserController.signUp);
    router.get('/verify_email/:token', UserController.VerifyEmail);
    router.post('/login', UserController.Login);
    router.post('/forget_password', auth_1.requiresAuth, UserController.forgotPassword);
    router.post('/reset_password/:token', UserController.resetPassword);
    router.patch('/change_password', auth_1.requiresAuth, UserController.changePassword);
    router.patch('/update_user_profile', auth_1.requiresAuth, UserController.updateUserProfile);
    return router;
}
