"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mongoose_1 = require("mongoose");
const VerifySchema = new mongoose_1.Schema({
    email: { type: String, required: true, unique: true },
    createdAt: { type: Date, default: Date.now },
    expireAt: { type: Date, default: Date.now, index: { expires: '1h' } }
});
VerifySchema.pre('save', function (next) {
    this.expireAt = new Date(Date.now() + 60 * 60 * 1000);
    next();
});
exports.default = (0, mongoose_1.model)("Verify", VerifySchema);
